//----------------------------------------------------------------
// GUI Frame 
// Programmr: Bjrk Busch nov.2001/2002
//----------------------------------------------------------------

import javabook.Convert;
import java.awt.*;
import java.awt.event.*;

public	class GuiEkstraFrame extends Frame
{
  // Skrmdata

  private Label      dataLabel      = new Label ("data:");
  private TextField  dataField      = new TextField ("",50);

  private Button     hentKnap       =	new Button("Hent data fra");
  private Button     retKnap        =	new Button("Ret data i model");
  private Button     nyDialogKnap 	=	new Button("Start ny Dialog med adgang til model");


  // Modelkomponent 
  ModelKlasse		model;


  public GuiEkstraFrame (ModelKlasse	model)			/* constructor */
  {

    this.model = model;		// gem reference til model til senere brug

    // opbygning af skrmbillede
    setSize(400,200);
    setTitle("Ekstra frame med adgang til Global.model  -  Systemeksempel udarbejdet af Bjrk Busch");

    setLayout(new FlowLayout(FlowLayout.CENTER, 10, 10));		

    add(dataLabel);
    add(dataField);

    add(hentKnap);
    hentKnap.addActionListener(new HentKnapActionListener());

    add(retKnap);
    retKnap.addActionListener(new RetKnapActionListener());

    add(nyDialogKnap);
    nyDialogKnap.addActionListener(new NyDialogKnapActionListener());
  }

  private	void hent()
  {
    dataField.setText(""+model.getData());
  }
  private	void ret()
  {
    model.setData(dataField.getText());
  }

  private	void opretNyDialog ()
  {
    GuiDialog  nyDialog = new GuiDialog (this, true, model);
    nyDialog.overfoerDataTilDialog("Data fra ekstaFrame: "+dataField.getText());
    nyDialog.show();
    System.out.println("Retur fra nyDialog: "+nyDialog.overfoerDataFraDialog());
  }

  //=============================================================================
  // event-handlere
  private	class HentKnapActionListener implements java.awt.event.ActionListener
  {
    public void actionPerformed(ActionEvent e)
    {
      hent();
    }
  }
  private	class RetKnapActionListener implements java.awt.event.ActionListener
  {
    public void actionPerformed(ActionEvent e)
    {
      ret();
    }
  }
  private	class NyDialogKnapActionListener implements java.awt.event.ActionListener
  {
    public void actionPerformed(ActionEvent e)
    {
      opretNyDialog ();
    }
  }



} // slut p frame-klasse